#include<fstream>
#include<iostream>
#include<cstdio>
#include<cstring>

using namespace std;
int accno=1001;

class bank
     {
       	       long actno;
	       char name[30];
	       long phone;
	       float balance;	
	       int age;
	       char fname[30];
	       char address[50];
	       char emailadd[25];
	public:
		bank()
		{
		name[0]="\0";
		balance=0;
		age=0;
		}

	       void modification();
	       void addition();
	       void del();
	       void verify();
	       void menu();
	       void search();
	       void getdata();
	       void display();
	       void view();
	       void transaction();	
	       char check(char *);
	       int test();
	    }obj;

int bank::test()    //FIND NO. OF RECORDS
    {
	fstream f;
	f.open("bank11.dat",ios::app|ios::binary);
	int t=f.tellg();
	t/=sizeof(obj);
	f.close();
      return t ;
    }


void bank::addition()  //ADDING  INFORMATION
    {
      ofstream fout;
      getdata();
      fout.open("bank11.dat",ios::app|ios::binary);
      fout.write((char*)&obj,sizeof(obj));
      fout.close();
    }

void bank::getdata()  // ENTERING THE DETAILS
    {

      char ch;
      cout<<" [ADDITION] ";
      obj.actno=accno++;
      cout<<" \n ENTER NAME : ";
      cin.getline(obj.name,30,'\n');
      cout<<" \n ENTER FATHER's NAME : ";
      cin.getline(obj.fname,30,'\n');
      cout<<" \n ENTER HOUSE PHONE NUMBER : ";
      cin>>obj.phone;
      cin.get(ch);
      cout<<" \n ENTER HOUSE ADDRESS : ";
      cin.getline(obj.address,50,'\n');
      cout<<" \n ENTER EMAIL ADDRESS : ";
      cin.getline(obj.emailadd,25,'\n');
      transaction();
	
      }


void bank::display() //TO DISPLAY A RECORD
    {
      cout<<"\n";
      cout<<" Account NO:"<<obj.actno<<"\n";
      cout<<" NAME : "<<obj.name<<"\n";
      cout<<" BALANCE  :"<<obj.balance<<"\n";	
      cout<<" FATHER'S NAME: "<<obj.fname<<"\n";
      cout<<" PHONE NUMBER : "<<obj.phone<<"\n";
      cout<<" HOUSE ADDRESS : "<<obj.address<<"\n";
      cout<<" EMAIL ADDRESS : "<<obj.emailadd<<"\n";
     
    }


void bank:: transaction()
{
	char ch;
	float amount;
	if (balance==0)
		ch='d';
	else
	{
	
		cout<<"Enter what you wish to do:"<<endl<<"Withdrawl-W    Deposit- D";
		cin>>ch;
	}
	switch(ch)
		{
		case 'W':
		case 'w':	cout<<"Enter the amount to be withdrawn:";
				cin>>amount;
				if(balance<amount)
				{cout<<endl<<"Insufficient funds. Sorry your transaction has been cancelled";
				return;
				}
				else
				{
				obj.balance-=amount;
				cout<<endl<<"collect your cash";
				}
				break;
		case 'd':
		case 'D': 	cout<<"Enter the amount to be deposited:";
				cin>>amount;
				obj.balance+=amount;
				cout<<endl<<"the balance available now is:"<<obj.balance;
		}

}

void bank::modification() //TO MODIFY ANY DATA IN  THE RECORD IF NECESSARY
   {
     
		    cout<<" [ MODIFICATION ] ";
		    long pn;
		    int n,i;
		    ofstream fout;
		    ifstream fin; 
		    n=test();
		    if(n==0)
		      {
			cout<<"\n FILE IS EMPTY ! ";
			return;
		      }
		   
		   char ch;
		   cout<<"\n ENTER ACCOUNT NO. :";
		   cin>>pn;
		   ch=cin.get();
			int pos;
			pos=pn-1000;	
			 
			fin.seekg((pos-1)*sizeof(obj),ios::beg);
			fin.read((char*)&obj,sizeof(obj));	     
			fin.close();
			if(check("NAME")=='y')
			  {
			    cout<<"\n ENTER NEW NAME : ";
			    cin.getline(name,30,'\n');
			  }
			if(check("FATHER'S NAME")=='y')
			  {
			    cout<<"\n ENTER NEW FATHER’S NAME :";
			    cin.getline(fname,30,'\n');
			  }
			if(check("PHONE NUMBER")=='y')
			  {
			    cout<<"\n ENTER NEW PHONE NUMBER :";
			    cin>>phone;
			    ch=cin.get();
			  }

			if(check("HOME ADDRESS")=='y')
			  {
			    cout<<"\n ENTER NEW ADDRESS :";
			    cin.getline(address,50,'\n');
			  }
			if(check("EMAIL ADDRESS:")=='y')
			  {
			    cout<<"\n ENTER NEW MAIL ADDRESS :";
			    cin.getline(emailadd,25,'\n');
			}

fout.open("bank11.dat",ios::app|ios::binary);		
    fout.seekg((pos-1)*sizeof(obj),ios::beg);
  fout.write((char*)&obj,sizeof(obj));
  fout.close();
   
 }
char  bank::check(char *s)
    {
       cout<<"\n MODIFY \t "<<s<<"\t"<<"Y/N";
       char ch;
      cin>>ch;
      if((ch=='y')||(ch=='Y'))
	return 'y';
       else
	return 'n';
    }

void bank::search()
	{
	int pos=actno-1000;
	view(pos);
	return;
	}

void bank::view(int pos)
	{
	fstream f;
	f.open("bank11.dat", ios::in| ios::binary);
	f.read((char*)&obj,sizeof(obj));
	f.seekg((pos-1)*sizeof(obj),ios::beg);
	display();
	return;
	}
void  bank::menu()
    {
       char ch;
       cout<<"\t \n A:ADDITION \n  ";
       
           
       cout<<" \tM:MODIFICATION \n  ";
       
             
       cout<<" \tS:SEARCH \n  ";
	 
       cout<<"\t T:Transaction  \n  ";

       cout<<"\t D:DELETION \n   ";

       cout<<"\t E:EXIT \n  ";

       cin>>getch();

      switch(ch)
	   {
	     case 'a':
	     case 'A':
		addition();
		break;
	     case 'd' :
	     case 'D' :
		del();
		break;
		
	     case 't':
		case'T':
		transaction();
		break;
	     case 'm':
	     case 'M':
		modification();
		break;
	     
	     case 's':
	     case 'S':
		search();
		break;
	     case 'e':
	     case 'E':
		system("clear");
		exit(0);
		break;
	default:cout<<"Enter valid code!!";
	 }
}

int main()
{
cout<<"\n\n\t\tWelcome to the Banking System"<<endl<<endl;
for(;;)
{obj.menu();}
return 0;
}

